﻿using System;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Design;
using Wisej.Core;
using Wisej.Web;

namespace Wisej.PropertyGridCustomEditors
{
	public class DataRecordCountEditor : UITypeEditor
	{
		public override object EditValue(ITypeDescriptorContext context, IServiceProvider provider, object value)
		{
			var editorService = (IWisejEditorService)provider.GetService(typeof(IWisejEditorService));

			var count = (int)value;
			var editor = new NumericUpDown() { Value = count };
			editorService.DropDownControl(editor);
			return editor.Value;
		}

		public override bool GetPaintValueSupported(ITypeDescriptorContext context)
		{
			return true;
		}

		public override void PaintValue(PaintValueEventArgs e)
		{
			var g = e.Graphics;
			var count = (int)e.Value;
			var color = Color.Empty;

			if (count < 2)
				color = Color.Blue;
			else if (count < 5)
				color = Color.Yellow;
			else if (count < 8)
				color = Color.Orange;
			else
				color = Color.Red;

			using (var brush = new SolidBrush(color))
			{
				g.FillRectangle(brush, e.Bounds);
			}
		}
	}
}